<?php
set_time_limit(0);
error_reporting(1);

$argc = $_SERVER['argc'];
$argv = $_SERVER['argv'];

$sys_folder = 'SYS';
$oem_folder = 'OEM';
$lite_folder = 'LITE';
$deleted_folder = 'deleted';

$create_oem_only = false;
$ignore_deleted_folder = false;

for ($i = 1; $i < $argc; $i++) {
    if (strcasecmp($argv[$i], "ignore_deleted_folder") == 0)
        $ignore_deleted_folder = true;
    else if (strcasecmp($argv[$i], "create_oem_only") == 0)
        $create_oem_only = true;
    else if (strncasecmp($argv[$i], "kernel=", 7) == 0) {
        $ver = substr($argv[$i], 7);
        if ($ver !== '')
            $sys_folder = 'SYS_'.$ver;
    }
    else {
        echo "unknown parameter: ".$argv[$i]."\n";
        exit;
    }
}

if (!is_dir($sys_folder)) {
    echo "No SYS folder ($sys_folder) under current directory!\n";
    exit;
}

if (!is_dir($oem_folder)) {
    echo "No OEM folder ($oem_folder) under current directory!\n";
    exit;
}

if (!is_dir($lite_folder)) {
    echo "No LITE folder ($lite_folder) under current directory!\n";
    exit;
}

$lang = FindLanguage($sys_folder);

if ($lang === false) {
    echo "Can't detect language from SYS folder\n";
    exit;
}

echo "CurLang = $lang\n";

if (!$ignore_deleted_folder && !$create_oem_only && file_exists($deleted_folder)) {
    echo "deleted folder already exist, please delete it before run this program!\n";
    exit;
}
@mkdir($deleted_folder);
if (!is_dir($deleted_folder)) {
    echo "Can't create deleted folder.\n";
    exit;
}

$lite_lang = array();
$fp = fopen($lite_folder.'\\lang.txt', 'rb');
if ($fp !== 0) {
    while(!feof($fp)) {
        $my_lang = trim(fgets($fp));
        if ($my_lang === '' || strlen($my_lang) != 4) continue;
        $lite_lang[] = $my_lang;
        echo "Lang in LITE = $my_lang\n";
    }
    fclose($fp);
}

if (!$create_oem_only) {
    // load deleted_files.txt
    $deleted_files = array();
    $fp = fopen($lite_folder.'\\deleted_files.txt', 'rb');
    if ($fp !== 0) {
        echo "Processing deleted_files.txt\n";
        while (!feof($fp)) {
            $file = strtolower(trim(fgets($fp)));
            if ($file === '') continue;
            if (!in_array($file, $deleted_files))
                $deleted_files[] = $file;
            if (count($lite_lang) != 0) {
                foreach ($lite_lang as $my_lang) {
                    if (strcmp(substr($file, -4), '.exe') == 0 || strcmp(substr($file, -4), '.dll') == 0) {
                        // automatic add the mui file for exe and dll
                        $mui_file = $file.'.'.$my_lang.'.mui';
                        if (!in_array($mui_file, $deleted_files))
                            $deleted_files[] = $mui_file;
                    }
                }
            }
        }
        fclose($fp);
    }

    // load deledted files from OEM setting also
    $dh = opendir($lite_folder.'\\OEM');
    if ($dh) {
        while (($file = readdir($dh)) !== false) {
            if ($file == '.' || $file == '..') continue;
            $file_name = $lite_folder.'\\OEM\\'.$file;
            if (!is_file($file_name)) continue;
            // load .txt only
            if (strcasecmp(substr($file, -4), '.txt')) continue;
            $fp = fopen($file_name, 'rb');
            if ($fp !== 0) {
                echo "Loading deleted files from $file_name\n";
                while (!feof($fp)) {
                    $file = strtolower(trim(fgets($fp)));
                    if ($file === '') continue;
                    if (!in_array($file, $deleted_files))
                        $deleted_files[] = $file;
                    if (count($lite_lang) != 0) {
                        foreach ($lite_lang as $my_lang) {
                            if (strcmp(substr($file, -4), '.exe') == 0 || strcmp(substr($file, -4), '.dll') == 0) {
                                // automatic add the mui file for exe and dll
                                $mui_file = $file.'.'.$my_lang.'.mui';
                                if (!in_array($mui_file, $deleted_files))
                                    $deleted_files[] = $mui_file;
                            }
                        }
                    }
                }
                fclose($fp);
            }
        }
        closedir($dh);
    }

    // move deleted files
    foreach (array($sys_folder, $oem_folder) as $root_folder) {
        $dh = opendir($root_folder);
        if (!$dh) {
            echo "opendir() failed for $root_folder\n";
            continue;
        }

        while (($file = readdir($dh)) !== false) {
            if ($file == '.' || $file == '..') continue;
            $folder_name = $root_folder.'\\'.$file;
            // only process directory
            if (filetype($folder_name) !== 'dir') continue;
            // skip OEM\zzzXXXXXX
            if (strncasecmp($folder_name, 'OEM\\zzz', 7) == 0) continue;

            echo "Processing directory: $folder_name\n";
            $sub_dh = opendir($folder_name);
            if (!$sub_dh) {
                echo "opendir() failed for $folder_name\n";
                continue;
            }
            while (($file = readdir($sub_dh)) !== false) {
                if ($file == '.' || $file == '..') continue;
                $lwr_file = strtolower($file);
                $full_name = $folder_name.'\\'.$file;
                if (in_array($lwr_file, $deleted_files)) {
                    echo "$file\n";
                    @mkdir($deleted_folder.'\\'.$root_folder);
                    @mkdir($deleted_folder.'\\'.$folder_name);
                    $new_full_name = $deleted_folder.'\\'.$full_name;
                    rename($full_name, $new_full_name);
                }
                else if (count($lite_lang) != 0) {
                    foreach ($lite_lang as $my_lang) {
                        $new_file = str_replace($lang, $my_lang, $file);
                        $lwr_new_file = strtolower($new_file);
                        if (in_array($lwr_new_file, $deleted_files)) {
                            echo "$file (replace language to $new_file)\n";
                            @mkdir($deleted_folder.'\\'.$root_folder);
                            @mkdir($deleted_folder.'\\'.$folder_name);
                            $new_full_name = $deleted_folder.'\\'.$full_name;
                            rename($full_name, $new_full_name);
                        }
                    }
                }
            }
            closedir($sub_dh);
        }
        closedir($dh);
    }
    $deleted_files = array();
    unset($deleted_files);

    // delete the file if only have .dsm
    echo "Processing .dsm only\n";
    $dh = opendir($sys_folder);
    if ($dh) {
        while (($file = readdir($dh)) !== false) {
            if ($file == '.' || $file == '..') continue;
            $folder_name = $sys_folder.'\\'.$file;
            // only process directory
            if (filetype($folder_name) !== 'dir') continue;

            echo "Processing directory: $folder_name\n";
            $sub_dh = opendir($folder_name);
            if (!$sub_dh) {
                echo "opendir() failed for $folder_name\n";
                continue;
            }
            $count = 0;
            $total_files = 0;
            while (($file = readdir($sub_dh)) !== false) {
                if ($file == '.' || $file == '..') continue;
                $total_files++;
                // skip .dsm files
                if (strcasecmp(substr($file, -4), '.dsm') == 0) continue;
                $count++;
            }
            closedir($sub_dh);
            if ($count == 0) {
                // only .dsm for this folder
                $sub_dh = opendir($folder_name);
                if (!$sub_dh) {
                    echo "opendir() failed for $folder_name\n";
                    continue;
                }
                while (($file = readdir($sub_dh)) !== false) {
                    if ($file == '.' || $file == '..') continue;
                    $full_name = $folder_name.'\\'.$file;
                    echo "$file\n";
                    @mkdir($deleted_folder.'\\'.$sys_folder);
                    @mkdir($deleted_folder.'\\'.$folder_name);
                    $new_full_name = $deleted_folder.'\\'.$full_name;
                    rename($full_name, $new_full_name);
                }
                closedir($sub_dh);
            }
            if ($total_files == 0 || $count == 0) {
                echo "Remove empty directory: $folder_name\n";
                @rmdir($folder_name);
            }
        }
        closedir($dh);
    }

    // process deleted registry
    $fname = $lite_folder.'\\deleted_registry.txt';
    $fp = fopen($fname, 'rb');
    if ($fp !== 0) {
        echo "Processing deleted_registry.txt\n";
        $deleted_registry = array();
        $deleted_registry_item = array();
        $bom1 = fread($fp, 1);
        $bom2 = fread($fp, 1);
        if (ord($bom1) !== 255 && ord($bom2) != 254) {
            echo "This file is not a UTF16-LE format.\n";
        }
        else {
            $file_data = iconv('UTF-16LE', 'UTF-8//IGNORE', fread($fp, filesize($fname)));
            $item_mode = false;
            $item_key = '';
            $data_array = explode("\r\n", $file_data);
            unset($file_data);
            foreach ($data_array as $line) {
                $key = trim($line);
                if ($key === '') continue;
                if (substr($key, 0, 1) == '!') {
                    $item_mode = true;
                    continue;
                }
                if (!$item_mode) {
                    if (substr($key, 0, 1) == '[')
                        $deleted_registry[] = $key;
                    continue;
                }
                // item mode here
                if (substr($key, 0, 1) == '[') {
                    $item_key = $key;
                    continue;
                }
                if ($item_key === '') {
                    echo "format error, no item key.\n";
                    continue;
                }
                $deleted_registry_item[$item_key][] = $key;
            }
            unset($data_array);
        }
        fclose($fp);
        if (count($deleted_registry) != 0 || count($deleted_registry_item) != 0) {
            foreach (array($sys_folder, $oem_folder) as $root_folder) {
                $dh = opendir($root_folder);
                if (!$dh) {
                    echo "opendir() failed for $root_folder\n";
                    continue;
                }

                while (($file = readdir($dh)) !== false) {
                    if ($file == '.' || $file == '..') continue;
                    $folder_name = $root_folder.'\\'.$file;
                    // only process directory
                    if (filetype($folder_name) !== 'dir') continue;
                    // skip OEM\zzzXXXXXXX
                    if (strncasecmp($folder_name, 'OEM\\zzz', 7) == 0) continue;

                    echo "Processing directory: $folder_name\n";
                    $sub_dh = opendir($folder_name);
                    if (!$sub_dh) {
                        echo "opendir() failed for $folder_name\n";
                        continue;
                    }
                    while (($file = readdir($sub_dh)) !== false) {
                        if ($file == '.' || $file == '..') continue;
                        // skip non .rgu files
                        if (strcasecmp(substr($file, -4), '.rgu')) continue;
                        if (strcasecmp($file, 'a42951a4-0a5d-4916-b730-c1a17032cb2c.rgu')) continue;
                        $full_name = $folder_name.'\\'.$file;
                        // found .rgu here
                        echo "Processing $full_name\n";
                        $fp = fopen($full_name, "rb");
                        if ($fp == 0) {
                            echo "Can't open file: $full_name\n";
                            continue;
                        }
                        $bom1 = fread($fp, 1);
                        $bom2 = fread($fp, 1);
                        if (ord($bom1) !== 255 && ord($bom2) != 254) {
                            fclose($fp);
                            echo "This file is not a UTF16-LE format.\n";
                            continue;
                        }
                        $file_data = iconv('UTF-16LE', 'UTF-8//IGNORE', fread($fp, filesize($full_name)));
                        fclose($fp);
                        $tmp_file = $lite_folder.'\\'.$file;
                        $tmp_fp = fopen($tmp_file, 'wb');
                        if ($tmp_fp == 0) {
                            echo "Can't create tmp file: $tmp_file\n";
                            continue;
                        }
                        // write BOM
                        fwrite($tmp_fp, chr(255), 1);
                        fwrite($tmp_fp, chr(254), 1);
                        $modified = false;
                        $deleted_key = false;
                        $deleted_item = false;
                        $item_key = '';
                        $data_array = explode('\r\n', $file_data);
                        foreach ($data_array as $line) {
                            $key = trim($line);
                            if (substr($key, 0, 1) == '[') {
                                $deleted_key = false;
                                $deleted_item = false;
                                if (in_array($key, $deleted_registry)) {
                                    $deleted_key = true;
                                    $modified = true;
                                    echo "Delete registry: $key\n";
                                    continue;
                                }
                                if (isset($deleted_registry_item[$key])) {
                                    echo "try to found item for $key\n";
                                    $item_key = $key;
                                    $deleted_item = true;
                                }
                            }
                            if ($deleted_key) continue;
                            if ($deleted_item) {
                                $pos = strpos($key, '=');
                                if ($pos !== false) {
                                    $item = substr($key, 0, $pos);
                                    if (in_array($item, $deleted_registry_item[$item_key])) {
                                        $modified = true;
                                        echo "Delete item: $item from registry $item_key\n";
                                        continue;
                                    }
                                }
                            }
                            // nothing, so just output it
                            fwrite($tmp_fp, iconv('UTF-8', 'UTF-16LE//IGNORE', $key."\r\n"));
                        }
                        unset($file_data);
                        unset($data_array);
                        fclose($tmp_fp);
                        if (!$modified) {
                            echo "Skip non-modified file: $tmp_file\n";
                            unlink($tmp_file);
                            continue;
                        }
                        echo "move $full_name to $deleted_folder\\$file\n";
                        rename($full_name, $deleted_folder.'\\'.$file);
                        echo "move $tmp_file to $full_name\n";
                        rename($tmp_file, $full_name);
                    }
                    closedir($sub_dh);
                }
                closedir($dh);
            }
        }
    }
}

// move file to OEM folder
$dh = opendir($lite_folder.'\\OEM');
if ($dh) {
    $count = 0;
    while (($file = readdir($dh)) !== false) {
        if ($file == '.' || $file == '..') continue;
        $file_name = $lite_folder.'\\OEM\\'.$file;
        if (!is_file($file_name)) continue;
        // load .txt only
        if (strcasecmp(substr($file, -4), '.txt')) continue;
        $count++;
        $package_name = substr($file, 0, -4);
        // generate uuid from package name's md5sum
        $my_id_md5 = md5($package_name);
        $md5_len = strlen($my_id_md5);
        if ($md5_len < 32) {
            $extra_len = 32 - $md5_len;
            $s = '';
            for ($i = 0; $i < $extra_len; $i++)
                $s .= '0';
            $ss = $s.$my_id_md5;
            $my_id_md5 = $ss;
        }
        $my_id = substr($my_id_md5, 0, 8).'-'.substr($my_id_md5, 8, 4).'-'.substr($my_id_md5, 12, 4).'-'.substr($my_id_md5, 16, 4).'-'.substr($my_id_md5, 20, 12);
        $provxml_file = $lite_folder.'\\OEM\\'.$package_name.'.'.$lang.'.provxml';
        if (!file_exists($provxml_file))
            $provxml_file = $lite_folder.'\\OEM\\'.$package_name.'.provxml';
        $rgu_file = $lite_folder.'\\OEM\\'.$package_name.'.'.$lang.'.rgu';
        if (!file_exists($rgu_file))
            $rgu_file = $lite_folder.'\\OEM\\'.$package_name.'.rgu';
        $oem_folder_name = 'zzzOEM_'.str_replace(' ', '_', $package_name);

        $guid = '';
        echo "Process OEM Package: $package_name\n";
        $full_folder_name = $oem_folder.'\\'.$oem_folder_name;
        if (file_exists($full_folder_name)) {
            // folder already exist, try to get GUID
            $xml_file = $full_folder_name.'\\option.xml';
            $content = file_get_contents($xml_file);
            preg_match("#<Guid(.*)>(.*)</Guid>#", $content, $matches);
            if (count($matches) != 0) {
                $guid = $matches[2];
                echo "Exist GUID: $guid\n";
            }
        }
        if (!file_exists($full_folder_name) || $guid == '') {
            @mkdir($full_folder_name);
            // generate .dsm file, and option.xml
            $guid = $my_id;
            echo "New GUID: $guid\n";
            $dsm_file = $full_folder_name.'\\'.$guid.'.dsm';
            $fp = fopen($dsm_file, "wt");
            if ($fp == 0) {
                echo "Can't create file: $dsm_file\n";
                continue;
            }
            fclose($fp);
            $xml_file = $full_folder_name.'\\option.xml';
            $fp = fopen($xml_file, "wt");
            if ($fp == 0) {
                echo "Can't create file: $xml_file\n";
                continue;
            }
            fputs($fp, '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<Items>
<Item name="'.$package_name.'" group="OEM" checked="false">
<Tip>'.$package_name.'</Tip>
<Guid type="p">'.$guid.'</Guid>
<OEMDate>2009/12/31</OEMDate>
</Item>
</Items>');
            fclose($fp);
        }
        if (file_exists($provxml_file)) {
            $new_provxml_file = $full_folder_name.'\\mxip_zzzOEM_'.str_replace(' ', '_', $package_name).'_'.sprintf("%03d", $count).'.provxml';
            copy($provxml_file, $new_provxml_file);
        }
        if (file_exists($rgu_file)) {
            $new_rgu_file = $full_folder_name.'\\zzzOEM_'.str_replace(' ', '_', $package_name).'.rgu';
            copy($rgu_file, $new_rgu_file);
        }
        MoveFileToOEM($full_folder_name, $deleted_folder, $file_name, $lang, $lite_lang, $guid, $sys_folder, $oem_folder);
    }
    closedir($dh);
}

exit;

function FindLanguage($root_folder)
{
    $dh = opendir($root_folder);
    if (!$dh) {
        echo "opendir() failed for $root_folder\n";
        return false;
    }
    $lang = false;
    while (($file = readdir($dh)) !== false) {
        if ($file == '.' || $file == '..') continue;
        $full_name = $root_folder.'\\'.$file;
        if (!is_dir($full_name)) continue;
        if (strlen($file) != 14) continue;
        if (strncasecmp($file, 'Base_Lang_', 10)) continue;
        $lang = substr($file, 10);
        break;
    }
    closedir($dh);
    return $lang;
}

function MoveFileToOEM($full_folder_name, $deleted_folder, $file_name, $lang, $lite_lang, $guid, $sys_folder, $oem_folder)
{
    //echo "Moving file to $full_folder_name\n";
    $have_rgu = false;
    $fp = fopen($file_name, 'rb');
    if ($fp == 0) return;
    $oem_files = array();
    while (!feof($fp)) {
        $file = strtolower(trim(fgets($fp)));
        if ($file === '') continue;
        $oem_files[] = $file;
        if (count($lite_lang) != 0) {
            foreach ($lite_lang as $my_lang) {
                if (strcmp(substr($file, -4), '.exe') == 0 || strcmp(substr($file, -4), '.dll') == 0) {
                    // automatic add the mui file for exe and dll
                    $oem_files[] = $file.'.'.$my_lang.'.mui';
                }
            }
        }
    }
    fclose($fp);

    foreach (array($deleted_folder.'\\'.$sys_folder, $deleted_folder.'\\'.$oem_folder) as $root_folder) {
        $dh = opendir($root_folder);
        if (!$dh) {
            echo "opendir() failed for $root_folder\n";
            continue;
        }

        while (($file = readdir($dh)) !== false) {
            if ($file == '.' || $file == '..') continue;
            $folder_name = $root_folder.'\\'.$file;
            // only process directory
            if (filetype($folder_name) !== 'dir') continue;

            //echo "Processing directory: $folder_name\n";
            $sub_dh = opendir($folder_name);
            if (!$sub_dh) {
                echo "opendir() failed for $folder_name\n";
                continue;
            }
            while (($file = readdir($sub_dh)) !== false) {
                if ($file == '.' || $file == '..') continue;
                // skip .dsm file, we already have oem dsm file
                if (strcasecmp(substr($file, -4), '.dsm') == 0) continue;
                $full_name = $folder_name.'\\'.$file;
                $lwr_file = strtolower($file);
                if (in_array($lwr_file, $oem_files)) {
                    echo "$file\n";
                    $new_full_name = $full_folder_name.'\\'.$file;
                    rename($full_name, $new_full_name);
                }
                else if ($lite_lang !== '') {
                    $new_file = str_replace($lang, $lite_lang, $file);
                    $lwr_new_file = strtolower($new_file);
                    if (in_array($lwr_new_file, $oem_files)) {
                        echo "$file (replace language to $new_file)\n";
                        $new_full_name = $full_folder_name.'\\'.$file;
                        rename($full_name, $new_full_name);
                    }
                }
            }
            closedir($sub_dh);
        }
        closedir($dh);
    }

    // make sure there's only only .dsm with guid
    //echo "Checking .dsm files\n";
    $dh = opendir($full_folder_name);
    if (!$dh) {
        echo "opendir() failed for $full_folder_name\n";
        return;
    }

    $dsm_exists = false;
    while (($file = readdir($dh)) !== false) {
        if ($file == '.' || $file == '..') continue;
        // skip non .dsm files
        if (strcasecmp(substr($file, -4), '.dsm')) continue;
        // .dsm here
        if (strcasecmp($file, $guid.'.dsm') == 0) {
            $dsm_exists = true;
            continue;
        }
        // other .dsm,
        system("attrib -r -h -s \"$full_folder_name\\$file\"");
        unlink($full_folder_name.'\\'.$file);
    }
    closedir($dh);
    if (!$dsm_exists) {
        $fp = fopen($full_folder_name.'\\'.$guid.'.dsm', "wt");
        if (!$fp)
            fclose($fp);
    }

    // merge .rgu file to $guid.rgu
    //echo "Merging .rgu files\n";
    $dh = opendir($full_folder_name);
    if (!$dh) {
        echo "opendir() failed for $full_folder_name\n";
        return;
    }

    $lines = 0;
    $rgu_file = $full_folder_name.'\\'.$guid.'.rgu';
    $fp = fopen($rgu_file, "wb");
    if ($fp == 0) {
        closedir($dh);
        echo "Can't create $rgu_file file\n";
        return;
    }
    // write BOM
    fwrite($fp, chr(255), 1);
    fwrite($fp, chr(254), 1);
    fwrite($fp, iconv('UTF-8', 'UTF-16LE//IGNORE', "REGEDIT4\r\n"));

    while (($file = readdir($dh)) !== false) {
        if ($file == '.' || $file == '..') continue;
        // skip non .rgu files
        if (strcasecmp(substr($file, -4), '.rgu')) continue;
        // skip myself
        if (strcasecmp($file, $guid.'.rgu') == 0) continue;
        $rgu_fp = fopen($full_folder_name.'\\'.$file, "rt");
        $bom1 = fread($rgu_fp, 1);
        $bom2 = fread($rgu_fp, 1);
        if (ord($bom1) !== 255 && ord($bom2) != 254) {
            fclose($rgu_fp);
            echo "$file is not a UTF16-LE format.\n";
            continue;
        }
        while (!feof($rgu_fp)) {
            $str = fgets($rgu_fp);
            if (ord(substr($str, 0, 1)) == 0 && ord(substr($str, 1, 1)) != 0) {
                // remove first 0x00
                $utf8str = trim(iconv('UTF-16LE', 'UTF-8//IGNORE', substr($str, 1)));
            }
            else
                $utf8str = trim(iconv('UTF-16LE', 'UTF-8//IGNORE', $str));
            if (strcasecmp($utf8str, 'REGEDIT4') == 0) continue;
            if (strncasecmp($utf8str, 'Windows Registry Editor Version', strlen('Windows Registry Editor Version')) == 0) continue;
            fwrite($fp, iconv('UTF-8', 'UTF-16LE//IGNORE', $utf8str."\r\n"));
            $line++;
        }
        fclose($rgu_fp);
    }
    fclose($fp);
    closedir($dh);
    if ($line == 0) {
        // empty rgu files, delete it
        unlink($rgu_file);
    }
    return;
}

?>
